<script setup>
// ----------------------------------------------------------------
// Import
// ----------------------------------------------------------------

import { HeatmapChart } from "echarts/charts";
import {
  CalendarComponent,
  ToolboxComponent,
  TooltipComponent,
  VisualMapComponent,
} from "echarts/components";
// To see the list of imports, copy the final content of option (after setup) into the site:
// https://vue-echarts.dev/#codegen
import { use } from "echarts/core";
import { CanvasRenderer } from "echarts/renderers";
import { provide, ref } from "vue";
import VChart, { THEME_KEY } from "vue-echarts";

// ----------------------------------------------------------------
// Probs
// ----------------------------------------------------------------

const props = defineProps({
  data: {
    type: Object,
    required: true,
  },
});

use([
  TooltipComponent,
  ToolboxComponent,
  VisualMapComponent,
  CalendarComponent,
  HeatmapChart,
  CanvasRenderer,
]);

// ----------------------------------------------------------------
// Variables
// ----------------------------------------------------------------

const maxValue = ref(1);
const dynamicHeight = ref("300px");
const option = ref({
  tooltip: {
    position: "top",
  },
  toolbox: {
    show: true,
    feature: {
      saveAsImage: {},
    },
  },
  visualMap: {
    min: 0,
    max: 1,
    calculable: true,
    orient: "horizontal",
    left: "center",
    top: "top",
  },
  calendar: [],
  series: [],
});

const loading = ref(true);

provide(THEME_KEY, "light");

// ----------------------------------------------------------------
// Functions
// ----------------------------------------------------------------

function convertDictFormat(originalObj) {
  const transformedArray = [];
  for (const key in originalObj) {
    const value = originalObj[key];
    transformedArray.push([key, value]);
    if (value > maxValue.value) {
      maxValue.value = value;
    }
  }

  return transformedArray;
}

// ----------------------------------------------------------------
// Watch
// ----------------------------------------------------------------

watch(
  () => props.data,
  async () => {
    if (props.data !== null) {
      const series = [];
      const calendar = [];
      let count = 0;
      for (const key in props.data) {
        series.push({
          type: "heatmap",
          coordinateSystem: "calendar",
          calendarIndex: count,
          data: convertDictFormat(props.data[key]),
        });

        calendar.push({
          range: key,
          cellSize: ["auto", 20],
          top: count === 0 ? 70 : count * 190 + 70,
        });

        count += 1;
      }

      option.value.series = series;
      option.value.calendar = calendar;
      option.value.visualMap.max = maxValue.value;
      dynamicHeight.value = `${(count + 1) * 190 + 70}px`;
      loading.value = false;
    }
  },
);
</script>

<template>
  <h2 v-if="loading === false">
    Data association calendar
  </h2>
  <VChart
    v-if="loading === false"
    class="chart"
    :option="option"
  />
  <v-skeleton-loader v-else type="image" />
</template>

<style scoped>
.chart {
  height: v-bind(dynamicHeight);
  width: 100%;
}
</style>
